import java.time.LocalDateTime;
import java.util.Calendar;
import java.util.Date;
import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

public class Bebida extends Producto implements Serializable{
	private boolean gaseoso;
	private boolean lacteo;
	String medida; // cent. cbicos
	DateFormat df = new SimpleDateFormat("dd-MM-yyyy");
	Date fecha_envase;
	
	
	public Bebida(int veces,String nombre,double precio,double subtotal,String estado,Date fecha_caducidad,boolean gaseoso,boolean lacteo,String cc,Date fecha_envase) {
		super(veces,nombre,precio,subtotal,estado,fecha_caducidad);
		this.setGaseoso(gaseoso);
		this.setLacteo(lacteo);
		this.setMedida(cc);
		this.setFecha_envase(fecha_envase);
	}
	
	// Constructor para el men para elegir productos
	public Bebida(String nombre,double precio) {
		super(nombre,precio);
	}
	
	// Constructor para mostrar los productos que aadimos al pedido
	public Bebida(int veces,String nombre,double precio,double subtotal) {
		super(veces,nombre,precio,subtotal);
	}
	
	@Override
	public Date obtener_caducidad() {
				
		// Si el elemento es perecedero,
		// la fecha de caducidad ser diez das ms de la fecha de envase.
		Calendar c = Calendar.getInstance();
		c.setTime(fecha_envase);
        
		if(isLacteo()==true) {			
	        c.add(Calendar.DATE, 10);
		}else {
			c.add(Calendar.DATE, 20);
		}
        	
		fecha_caducidad = c.getTime();
		//System.out.println("Fecha de caducidad: "+df.format(fecha_caducidad));
		
		return fecha_caducidad;
	}
	
	public String obtener_estado() {
		Date f_caducidad = obtener_caducidad();
		Date f_actual = new Date();
		
		// 86400000 son milisegundos que tiene un da
		int dias=(int) ((f_actual.getTime()-f_caducidad.getTime())/86400000);
		
		if(dias>=0) {
			
			super.estado = "CADUCADO";
		}
		
		if(dias<0 && dias>-5) {
			super.estado = "OFERTA";
			super.setPrecio(precio-(0.30*precio));
			super.setSubtotal(subtotal-(0.30*subtotal));
			//super.precio=super.precio-(0.30*super.precio);
			//super.subtotal=super.subtotal-(0.30*super.subtotal);
		}
		
		//System.out.println("DIAS DE CADUCIDAD: "+dias);
				
		return estado;
	}
	
	
	
	public void detalle_producto() {
		System.out.println("Detalles del Producto:");
		System.out.println("**********************");
		System.out.println("");
		System.out.println("Nombre: "+getNombre());
		System.out.println("Precio: "+getPrecio());
		
		if(isGaseoso()==true) {
			System.out.println("Bebida con gas");
		}else {
			System.out.println("Bebida sin gas");
			
		}
		if(isLacteo()==true) {
			System.out.println("Bebida lctea");
		//	System.out.println("Fecha de Caducidad (+10 dias): "+getFecha_caducidad());
		}else {
			System.out.println("Bebida NO lctea");
		//	System.out.println("Fecha de Caducidad (standard): "+getFecha_caducidad());
		}
		System.out.println("Volumen: "+getMedida()+" centmetros cbicos");
		
		System.out.println("Estado: "+getEstado());
	}
	

	
	// GETTERS AND SETTERS

	public boolean isGaseoso() {
		return gaseoso;
	}

	public void setGaseoso(boolean gaseoso) {
		this.gaseoso = gaseoso;
	}

	public boolean isLacteo() {
		return lacteo;
	}

	public void setLacteo(boolean lacteo) {
		this.lacteo = lacteo;
	}

	public String getMedida() {
		return medida;
	}

	public void setMedida(String medida) {
		this.medida = medida;
	}
	
	public Date getFecha_envase() {
		return fecha_envase;
	}

	public void setFecha_envase(Date fecha_envase) {
		this.fecha_envase = fecha_envase;
	}
	
}
