import java.util.Date;
import java.util.Scanner;
import java.io.Serializable;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.io.Serializable;


public class Cliente implements Serializable{
	
	String nombre,apellidos;
	Date FechaDeAlta = new Date(); 
	String telefono; 
	String direccion;

	ArrayList<Pedido> historial= new ArrayList<Pedido>();
	 // se pdra haber metido como local en el mtodo filtrarTelfono
	static boolean correcto=true; 
	
	
	public Cliente(String nom,String ape,String f,String phone,String direccion){
		this.setNombre(nom);
		this.setApellidos(ape);
		this.setFechaDeAlta(f);
		this.setTelefono(phone);
		this.setDireccion(direccion);
	}
	

	public Cliente(String nom,String ape,Date f,String phone,String direccion,ArrayList<Pedido> historial){
		this.setNombre(nom);
		this.setApellidos(ape);
		FechaDeAlta=f;
		setTelefono(phone);
		this.setDireccion(direccion);
		this.historial=historial;		
	}
	
	// Mtodos GET SET
		
	public void setNombre(String nom) {
		// Nos aseguramos que que el nombre slo tenga letras
		boolean esLetra=true;
		
		for (int i = 0; i < nom.length(); i++) {
	        if (!((nom.charAt(i)>='a' && nom.charAt(i)<='z') || (nom.charAt(i)>='A' && nom.charAt(i)<='Z')) ) {	
	            esLetra = false;
	            break;
	        }
	    }
	    //se podra haber puesto despus del bbreak, pero lo conoca aparte del switchh
	    if(esLetra==false){
	    	System.out.println("Error, el nombre contiene un caracter que no es una letra");
	    }else {
	    	// pasamos el nombre a minscula
	    	nombre=nom.toLowerCase();
	    }
		 
	}
	public String getNombre() {
		return nombre;
	}
	
	public void setApellidos(String ape) {

		//Nos aseguramos que el apellido slo tenga letras o espacio en blanco
		boolean esLetra=true;
		for (int i = 0; i < ape.length(); i++) {
	        if (!((ape.charAt(i)>='a' && ape.charAt(i)<='z') || (ape.charAt(i)>='A' && ape.charAt(i)<='Z' || ape.charAt(i)==' '))) {
	            esLetra = false; //aqu podra haber puesto tambien el bbreak
	        }
	    }
		if(esLetra==true) {
			// pasamos apellidos a maysculas
			apellidos=ape.toUpperCase();
		}else {
			System.out.println("Error, el apellido contiene un caracter que no es una letra o espacio");
		}


	}
	public String getApellidos() {
		return apellidos;
	}
	
	
	public void setFechaDeAlta(String f){	// formateador de fechas	
		SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
		// Java me obliga a usar try/catch para hacer parseo
		try {
			FechaDeAlta = sdf.parse(f);
		} catch (ParseException e) {			
			e.printStackTrace();
		}
	}
	public Date getFechaDeAlta() {
		return FechaDeAlta;
	}
	

	public void setTelefono(String phone) {		
		telefono=phone;		
	} 
	
	public String getTelefono() {
		return telefono;
	}
	
	public void setDireccion(String dir) {
		direccion=dir;
	}
	public String getDireccion() {
		return direccion;
	}

	
    public void setHistorial(Pedido p) {
        historial.add(p);
    }
	public ArrayList<Pedido> getHistorial() {
        return historial;
    }  

	
	// este mtodo lo llamaremos desde el main de GestionPedidos
	public static String filtrarTelefono() throws excepcionTelefono  {
		Scanner sc = new Scanner(System.in);
		System.out.print("\nINTRODUZCA TELFONO (0 SALIR): ");
		String phone = sc.nextLine();		
		System.out.println("");
		// Nos aseguramos que no hayan espacios en blanco
		phone.trim();
		phone.replace(" ","");
		
				
		if(!phone.equals("0") && !phone.isEmpty()){
		
			// Comprobamos que los caracteres sean numricos
			for(int i=0;i<phone.length();i++) {
				if(phone.charAt(i)<48 || phone.charAt(i)>57) {				
					//System.out.println("Error, hay un valor no numrico o negativo en el telfono");
					correcto=false;
					//break;
					throw new excepcionTelefono("Error, hay un valor no numrico o negativo en el telfono");
							
						
				}
			}
			// Comprobamos que el nmero de telfono tenga 9 dgitos y que empiece por 6,7,8 o 9
			if(phone.length()!=9) {
				//System.out.println("Error, el nmero de dgitos del telfono es incorrecto");
				correcto=false;
				throw new excepcionTelefono("Error, el nmero de dgitos del telfono es incorrecto");
				
			}
			if(phone.charAt(0)!='6' && phone.charAt(0)!='7' && phone.charAt(0)!='8' && phone.charAt(0)!='9') {
				//System.out.println("Error,el nmero de telfono no puede empezar con "+phone.charAt(0));
				correcto=false;
				throw new excepcionTelefono("Error,el nmero de telfono no puede empezar con "+phone.charAt(0));
				
			}
		}
		return phone;
	}
	
	
	// Otros Mtodos

	public void realizarPedido(Date f,ArrayList<Producto> pro,double impt,PasarelaDePago pa,String est) { 
		//crea pedido lo instanciamos/iniciamos
		Pedido nuevoPedido = new Pedido(this,f,pro,impt,pa,est);
		// NO BORRAR, PARA COMPROBAR EL PEDIDO
		//System.out.println("Este es el nuevo pedido: "+nuevoPedido); 		
		agregarPedido(nuevoPedido);
	}
	
	
	private void agregarPedido(Pedido nuevoPedido){
		
		Date fechaActual = new Date();
		boolean encontrado = false;
		// Recorremos todos los pedidos del historial y comparo fechas
		// Considerando los segundos, es improbable que puedan coincidir fechas
		for (int x = 0; x < historial.size(); x++) {
			Pedido p = historial.get(x);
			if (p.getFechaHora().equals(fechaActual)) {	
				encontrado = true;
				break; // Terminar ciclo, pues ya lo encontramos
			}
		}
		
		// TENIENDO EN CUENTA LOS SEGUNDOS, VA A SER CASI IMPOSIBLE
		// QUE PUEDAN COINCIDIR DOS PEDIDOS CON LA MISMA FECHA
		if(encontrado) {
			System.out.println("La fecha coincide y no aadimos pedido a historial");
		} else{  // si no hay otro pedido con igual fecha y est pagado va a historial
			System.out.println("La fecha no coincide, se puede pasar al historial");
			if(nuevoPedido.getEstado()=="PAGADO") {
				historial.add(nuevoPedido);

				// no debe haber pedidos repetidos en fecha y hora
			}else {
				System.out.println("No se puede aadir el pedido, no est pagado");
			}
		}
		
	}
	
	public static class excepcionTelefono extends Exception{
		String mensaje;
		public excepcionTelefono(String causa) {
			mensaje=causa;
		}
		@Override
		public String getMessage() {
			return mensaje;
		}
	}
	
	//  >>>> toString nos muestra los atributos de un objeto !!!
	
	@Override
	public String toString() {
			return getNombre()+" "+getApellidos();
	}
			
}


