import java.util.Calendar;
import java.util.Date;
import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

public class Comida extends Producto implements Serializable{
	private boolean perecedero;
	private float calorias;
	private boolean vegano;
	Date fecha_envase;
	DateFormat df = new SimpleDateFormat("dd-MM-yyyy");
	
	//(int veces,String nombre,double precio,double subtotal,String estado,Date fecha_caducidad)
	public Comida(int veces,String nombre,double precio,double subtotal,String estado,Date fecha_caducidad,boolean perecedero,float calorias,boolean vegano,Date fecha_envase) {
		super(veces,nombre,precio,subtotal,estado,fecha_caducidad);
		this.setPerecedero(perecedero);
		this.setCalorias(calorias);
		this.setVegano(vegano);
		this.setFecha_envase(fecha_envase);
	}
	
	// Constructor para el men para elegir productos
	public Comida(String nombre,double precio) {
		super(nombre,precio);
	}
	
	// Constructor para mostrar los productos que aadimos al pedido
	public Comida(int veces,String nombre,double precio,double subtotal) {
		super(veces,nombre,precio,subtotal);
	}
	
	@Override
	public Date obtener_caducidad() {
				
		// Si el elemento es perecedero,
		// la fecha de caducidad ser diez das ms de la fecha de envase.
		Calendar c = Calendar.getInstance();
		c.setTime(fecha_envase);
        
		if(isPerecedero()==true) {			
	        c.add(Calendar.DATE, 10);
		}
        	
		fecha_caducidad = c.getTime();
		//System.out.println("Fecha de caducidad: "+df.format(fecha_caducidad));
		
		return fecha_caducidad;
	}
	
	public String obtener_estado() {
		Date f_caducidad = obtener_caducidad();
		Date f_actual = new Date();
		
		// 86400000 son milisegundos que tiene un da
		int dias=(int) ((f_actual.getTime()-f_caducidad.getTime())/86400000);
		
		if(dias>=0) {
			
			super.estado = "CADUCADO";
		}
		
		if(dias<0 && dias>-5) {
			super.estado = "OFERTA";
			super.setPrecio(precio-(0.30*precio));
			super.setSubtotal(subtotal-(0.30*subtotal));
			//super.precio=super.precio-(0.30*super.precio);
			//super.subtotal=super.subtotal-(0.30*super.subtotal);
		}
		
		//System.out.println("DIAS DE CADUCIDAD: "+dias);
				
		return estado;
	}
	
	
	public void detalle_producto() {
		System.out.println("Detalles del Producto:");
		System.out.println("**********************");
		System.out.println("");
		System.out.println("Nombre: "+getNombre());
		System.out.println("Precio: "+getPrecio());
	//	System.out.println("Fecha de Caducidad: "+getFecha_caducidad());
		if(isPerecedero()==true) {
			System.out.println("Producto perecedero");
		}else {
			System.out.println("Producto NO perecedero");
		}
		System.out.println("Caloras: "+getCalorias());
		if(isVegano()==true) {
			System.out.println("Producto Vegano");
		}else {
			System.out.println("Producto NO Vegano");
		}
		
		
		System.out.println("Fecha de envasado: "+df.format(getFecha_envase()));
		
		System.out.println("Fecha de caducidad: "+df.format(fecha_caducidad));
		//System.out.println("Estado: "+getEstado());
		System.out.println("Estado: "+obtener_estado());
		
	}


	
	public boolean isPerecedero() {
		return perecedero;
	}

	public void setPerecedero(boolean perecedero) {
		this.perecedero = perecedero;
	}

	public float getCalorias() {
		return calorias;
	}

	public void setCalorias(float calorias) {
		this.calorias = calorias;
	}

	public boolean isVegano() {
		return vegano;
	}

	public void setVegano(boolean vegano) {
		this.vegano = vegano;
	}

	public Date getFecha_envase() {
		return fecha_envase;
	}

	public void setFecha_envase(Date fecha_envase) {
		this.fecha_envase = fecha_envase;
	}
}
