import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map.Entry;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Scanner;
import java.util.TreeMap;




public class GestionPedidos  implements Imprimible,Serializable
{			// para el men seleccione mtodo de pago
	static final String tipoPago_efectivo = "1";
	static final String tipoPago_tarjeta = "2";
	static final String tipoPago_cuenta = "3";
	
	static Date fechaActual = new Date();
	static DateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy  HH:mm");
	
	// inventario es para controlar en los men cuando no nos queden productos en listado
	static int inventario=0;
	static TreeMap<String, Producto> tmproped = main_crearTreeMapProductos();
	// es un treeMap de productos con atributos veces e item
	
	//static HashSet<Cliente> clienteHS = new HashSet<Cliente>();
	static HashSet<Cliente> cliHS = new HashSet<Cliente>();
	static File FILE_NAME = new File("clientes.dat");
	//static ArrayList<Cliente> cliHS = new ArrayList<Cliente>();

	//Muestra en pantalla si se desea Agregar, eliminar, pagar o Salir
	public static String menuOperacion(){
		System.out.println("\n########################");
		System.out.println("1.- AGREGAR PRODUCTO");
		System.out.println("2.- ELIMINAR PRODUCTO");
		System.out.println("3.- PAGAR");
		System.out.println("0.- SALIR");
		System.out.println("#########################\n");
		System.out.print("Seleciona operacion a realizar: (0 para salir): ");
		Scanner scOperacion = new Scanner(System.in);
		String operacion = scOperacion.nextLine();
		return operacion;
	}

	// Imprime el listado de productos del establecimiento
	public static void menuProductos(ArrayList<Producto> prolist){
		System.out.println("");
		System.out.println("Realizando pedido el " + new SimpleDateFormat("dd/MM/yyyy").format(fechaActual) + "...Su pedido:");
		System.out.println("\nAgregue los productos que desee a su pedido (0 para finalizar el pedido)");
		System.out.println("");
		System.out.println("PRODUCTO\t\t\tPRECIO UD.\n" + "===============\t\t\t=========");

		// productos para elegir del establecimiento
		for (int z = 0; z < prolist.size(); z++){
			System.out.println((z + 1) + ".-" + prolist.get(z).getNombre() + "\t\t\t" + prolist.get(z).getPrecio());
		}
	}

	public static TreeMap<String, Cliente> main_crearClientesEnTreeMap(){
		Cliente c1 = new Cliente("PePe", "pereZ Sanz", "02/09/2021", "615251426", "calle mar,8");
		Cliente c2 = new Cliente("BARtolo", "gIl miNguez", "12/01/12", "680325184", "avenida principal,21");
		Cliente c3 = new Cliente("piLaR", "marTinEz oChoa", "14/03/87", "777777777", "calle Victoria,32");
		Cliente c4 = new Cliente("mArisA", "MaZon hErnandez", "22/12/10", "863654874", "calle soria,1");
		Cliente c5 = new Cliente("mAnuEL", "SanCHEZ orTiZ", "13/11/45", "987654321", "calle valencia,45");

		// TreeMap para indexar telefono/cliente
		TreeMap<String, Cliente> tm = new TreeMap<String, Cliente>();
		tm.put(c1.telefono, c1);
		tm.put(c2.telefono, c2);
		tm.put(c3.telefono, c3);
		tm.put(c4.telefono, c4);
		tm.put(c5.telefono, c5);
		
		return tm;
	}
	

	public static void crearPasarelaDePago(Pedido ped, Cliente cl, String tipoPago){
		// instancio pasarela de pago pdp y la paso a pedido
		PasarelaDePago pdp = new PasarelaDePago(ped.getImporteTotal());
		pdp.setTipoPago(tipoPago); // quiz no tendra que llamarlo setTipo pago, no est en el constructor
		ped.setPago(pdp);
		try {
			ped.Pagar(tipoPago);
		} catch (PasarelaDePago.excepcionCuenta e) {
			e.printStackTrace();
		} catch (PasarelaDePago.excepcionTarjeta e) {
			e.printStackTrace();
		}


		// Hora y fecha del pedido
		Date fechayhora = new Date();
		ped.setFechaHora(fechayhora);
		System.out.println("\nHora y fecha del pedido: " + dateFormat.format(ped.getFechaHora()));

		ped.setEstado("PAGADO");
		
		// Creamos el pedido llamando al mtodo en Cliente
		cl.realizarPedido(ped.getFechaHora(), ped.getProducto(), ped.getImporteTotal(), pdp, ped.getEstado());
		// realizar pedido coge el pedido y aade a historial
				
		
		// nuevo cliente ya con su historial
		Cliente nuevoCliente = new Cliente(cl.getNombre(), cl.getApellidos(), cl.getFechaDeAlta(), cl.getTelefono(), cl.getDireccion(), cl.getHistorial());
				
		System.out.println("\nCLIENTE CON SU HISTORIAL: " + nuevoCliente + "\n" + nuevoCliente.getHistorial());

		System.out.println("");
		System.out.println("OPERACIN REALIZADA CON XITO");
				
		System.out.println("PEDIDO: "+pdp.getCodigoPago()+"\t FECHA: "+dateFormat.format(ped.getFechaHora())+"\t ESTADO: "+ped.getEstado());
		inventario=0;		
	}
	

	public static void main_agregarProductos(Pedido ped, ArrayList<Producto> prolist) throws ArrayIndexOutOfBoundsException,NumberFormatException{
		
		boolean seguirAgregando = true;
		String opcion;
		
		while (seguirAgregando){
			
			int numero;
			boolean esNumerico = true;
			
			do{
				menuProductos(prolist);
				System.out.println("");
				System.out.print("Aade nmero de producto: ");
				Scanner sc2 = new Scanner(System.in);
				opcion = sc2.nextLine();
				System.out.println("");
				// eliminamos posibles espacios en blanco, por si acaso
				opcion.trim();
				opcion.replace(" ", "");

				for (int w=0; w<opcion.length();w++){
					// que sea numrico
					if (opcion.charAt(w) < 48 || opcion.charAt(w)>57 || opcion.contains("-"))  {
						esNumerico = false;
						throw new NumberFormatException("Error, Valor no numrico !!");
						//System.out.println("OPCIN NO VLIDA");
						// break;
					} else{
						// parseamos, si no est fuera de rango, agregamos producto al pedido
						numero = Integer.parseInt(opcion);
						if (numero > prolist.size()){
							esNumerico = false;
							throw new ArrayIndexOutOfBoundsException("Opcin fuera de rango !!");
							//System.out.println("OPCIN NO VLIDA, NMERO FUERA DE RANGO");
						}else{
							if (!opcion.equals("0")){ // BUSCO SI EL PRODUCTO ELEGIDO YA EXISTE
								Producto proTmp = tmproped.get(opcion); // opcion es el producto elegido
								Producto pro= ped.buscar(proTmp);
													
								if (pro!=null) {
									// producto encontrado en el pedido actual
									pro.setVeces(pro.getVeces()+1);
									pro.setSubtotal(pro.getPrecio()+pro.getSubtotal());	
									ped.setImporteTotal(ped.getImporteTotal()+pro.getPrecio());;
																		
								//	System.out.println("encontrado");
								}
								else{  
									//producto no encontrado, lo CREO Y aado al pedido
														
									// Compruebo tipo y segn sea Comida o bebida aadimos
									if(tmproped.get(opcion) instanceof Comida) {
										//System.out.println("ES COMIDA");
										Comida com = (Comida)proTmp;
										ped.agregarProducto(com);
										
										com.obtener_caducidad();
										com.detalle_producto();
										//System.out.println("VALOR DE ESTADO:  "+com.getEstado());
										
										// ESTO LO AADO
										ped.setImporteTotal(ped.getImporteTotal()+com.getPrecio());;
																				
										System.out.println("");
									}
									
									if(tmproped.get(opcion) instanceof Bebida) {
										//System.out.println("ES BEBIDA");									
										Bebida beb = (Bebida)proTmp;
										ped.agregarProducto(beb);
										
										beb.obtener_caducidad();
										beb.detalle_producto();
										
										// ESTO LO AADO
										ped.setImporteTotal(ped.getImporteTotal()+beb.getPrecio());;
										
										System.out.println("");
									}
																														
									//System.out.println("No encontrado");
								}
								
								ped.mostrar();
								inventario++;
								//System.out.println("valor de inventario: "+inventario);					
							}else
								seguirAgregando = false;
						}
					}
				}
												
			}while( (esNumerico == false || opcion.isEmpty() == true) && !opcion.equals("0"));
		}	// fin while (seguirAgregando)	
	} // fin mainAgregarProducto()

	public static void resettmproped()
	{

			Producto pro = tmproped.get("1");
			pro.setVeces(0);
			pro = tmproped.get("2");
			pro.setVeces(0);
			pro = tmproped.get("3");
			pro.setVeces(0);
			pro = tmproped.get("4");
			pro.setVeces(0);
			pro = tmproped.get("5");
			pro.setVeces(0);
			pro = tmproped.get("6");
			pro.setVeces(0);
			pro = tmproped.get("7");
			pro.setVeces(0);

	}
	
	
	public static boolean main_resumen(Pedido ped, Cliente cl) throws IllegalArgumentException{
		
		System.out.println("\nRESUMEN DE SU PEDIDO:\n");
		ped.mostrar();
		String continuarConPago;
		do{
			System.out.print("\nContinuar con pago? (S/N): ");
			Scanner sc3 = new Scanner(System.in);
			// pasamos a maysculas la opcin "s" o "n"
			continuarConPago = sc3.nextLine().toUpperCase();
			/*
			if(!continuarConPago.equals("S") || !continuarConPago.equals("N")){
				throw new IllegalArgumentException("Slo se acepta S o N");
			}
*/
		} while (!continuarConPago.equals("S") && !continuarConPago.equals("N"));

		if (continuarConPago.equals("S")){
			System.out.println("\nIMPORTE: " + ped.getImporteTotal());
			System.out.println("\n1.- EFECTIVO.\n2.- TARJETA.\n3.- CUENTA\n");
			String tipoPago;

			// elegimos pagar en efectivo,tarjeta o cuenta	
			do{
				System.out.print("Seleccione un mtodo de pago: ");
				Scanner sc4 = new Scanner(System.in);
				tipoPago = sc4.nextLine();
			} while(!tipoPago.equals(tipoPago_efectivo)  && !tipoPago.equals(tipoPago_tarjeta) && !tipoPago.equals(tipoPago_cuenta));

			crearPasarelaDePago(ped, cl, tipoPago);
			//resettmproped();
			return false;
		}
		return true;
		
		
	}

	public static void main_borrarProducto(Pedido ped) throws ArrayIndexOutOfBoundsException,NumberFormatException{
		// operacion eliminar producto

		int tam_alProducto = ped.getProducto().size();
		
		int posi = 0;
		String numCadena;
		boolean esNumero;

		do{
			esNumero = true;
			System.out.print("\nInserta nmero de ITEM del elemento a borrar ");
			Scanner scPosicion = new Scanner(System.in);
			numCadena = scPosicion.nextLine();
			
			// filtramos que sea nmero
			for (int i = 0; i < numCadena.length(); i++){
				if (numCadena.charAt(i) < 48 || numCadena.charAt(i) > 57){
					//System.out.println("Error, has insertado algn valor no numrico");
					esNumero = false;
					throw new NumberFormatException("Error, valor NO numrico!!");
				}
			}

			if (esNumero == true){
				// si el valor de posi(item) es numrico
				posi = Integer.valueOf(numCadena);
				// filtramos que estn dentro del rango
				if (posi > tam_alProducto || posi <= 0){
					//System.out.println("ERROR, fuera de rango !!"); //
					esNumero = false;
					throw new ArrayIndexOutOfBoundsException("Error, valor fuera de rango!!");
				} else{
					// si es numerico y dentro del rango, eliminamos el producto
					ped.eliminarProducto(posi);
					inventario--;
					//System.out.println("valor de inventario: "+inventario);	
				}
			}

		}while (esNumero == false);
	}

	public static ArrayList<Producto> main_crearArrayProductos(){
		
		ArrayList<Producto> prolist = new ArrayList<Producto>();
		
		// Creamos productos del establecimiento
		Producto p1 = new Bebida("AgUA con gas", 0.35);
		Producto p2 = new Comida("BOCaDILLO   ", 3.55);
		Producto p3 = new Bebida("cErVEZA     ", 0.75);
		Producto p4 = new Bebida("Batido Fresa", 0.59);
		Producto p5 = new Comida("HAmbURGUESA ", 20.00);
		Producto p6 = new Comida("pizza       ", 7.55);
		Producto p7 = new Comida("lechuga     ",10.00);

		// Aadimos los productos del establecimiento a escoger
		prolist.add(p1);
		prolist.add(p2);
		prolist.add(p3);
		prolist.add(p4);
		prolist.add(p5);
		prolist.add(p6);
		prolist.add(p7);
		
		return prolist;
	}
	
	// guardamos los productos en un archivo
	public static void guarda_Productos(ArrayList<Producto> prolist) throws IOException {

		FileOutputStream fos = new FileOutputStream("productos.dat");
		ObjectOutputStream oos = new ObjectOutputStream(fos);
		oos.writeObject(prolist);
		oos.flush();
		if(oos!=null) {
			oos.close();
			fos.close();
		}
		
	}
	
	// cargamos e imprimimos los productos guardados en un fichero
	public static ArrayList<Producto> carga_Productos() throws IOException{
		
		ArrayList<Producto> listaProductos = new ArrayList<Producto>();
		
		FileInputStream fis = new FileInputStream("productos.dat");
	    ObjectInputStream ois = new ObjectInputStream(fis);

	    try {
			listaProductos = (ArrayList) ois.readObject();
		} catch (ClassNotFoundException | IOException e) {
			e.printStackTrace();
		}
	    
	    if(ois!=null) {
	    	ois.close();
	    	fis.close();
	    }
	    
	    return listaProductos;
	}
	


	////  ESCRIBIR CLIENTES EN FICHERO Y CARGAR ///////////
	
	public static void EscribirFichero(Cliente cl) {
	    ObjectOutputStream objectOutput = null;
	    ObjectInputStream objectInput = null;
	    HashSet<Cliente> cliHS = new HashSet<Cliente>();            
	    try {
	        if(FILE_NAME.exists()) {
	            objectInput = new ObjectInputStream(new FileInputStream(FILE_NAME));
	            cliHS = (HashSet<Cliente>) objectInput.readObject();
	        }        
	        cliHS.add(cl);        
	        objectOutput = new ObjectOutputStream(new FileOutputStream(FILE_NAME)); 
	        objectOutput.writeObject(cliHS);        
	        objectOutput.flush();
	        System.out.println("Se ha generado el fichero " + FILE_NAME);
	    } catch (FileNotFoundException e) {
	        e.printStackTrace();
	    } catch (IOException e) {
	        e.printStackTrace();
	    } catch (ClassNotFoundException e) {
	        e.printStackTrace();
	    } finally {
	        if (objectOutput != null) {
	            try {
	                objectOutput.close();
	            } catch (IOException ignored) {
	            }
	        }
	    }
	}

	

	public static void LeerFichero() {
	ObjectInputStream objectInput = null;
	try {
	    objectInput = new ObjectInputStream(new FileInputStream(FILE_NAME));
	    Object actual = null;
	    HashSet<Cliente> cliHS = null;      
	    while( ( actual = objectInput.readObject() ) != null ) {
	        cliHS = (HashSet<Cliente>) actual;          
	        Iterator it = cliHS.iterator();
	        while(it.hasNext()) {
	            System.out.println("Datos cliente: "+it.next());
	        }
	    }
	    objectInput.close();
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	} catch(EOFException e) {

	} catch (IOException e) {
	    e.printStackTrace();
	} catch (ClassNotFoundException e) {
	    e.printStackTrace();
	} finally {
	    if (objectInput != null) {
	        try {
	            objectInput.close();
	        } catch (IOException ignored) {
	        }
	    }
	}

	}

	

	
		
	

	
	
	public static TreeMap<String, Producto> main_crearTreeMapProductos(){

		// Sobrecarga de clase Producto	
		
		Producto proped1 = new Bebida(0, "AGUA CON GAS", 0.35, 0,"normal",new Date(),true,false,"50",new Date());
		Producto proped2 = new Comida(0, "BOCADILLO   ", 3.55, 0,"normal",new Date(),true,420,false,new Date());
		Producto proped3 = new Bebida(0, "CERVEZA     ", 0.75, 0,"normal",new Date(),true,false,"33",new Date());
		Producto proped4 = new Bebida(0, "Batido Fresa", 0.59, 0,"normal",new Date(),false,true,"20",new Date(121,4,1));
		Producto proped5 = new Comida(0, "HAMBURGUESA ", 20.00, 0,"normal",new Date(),true,500,false,new Date(121,3,1));
		Producto proped6 = new Comida(0, "PIZZA       ", 7.55, 0,"normal",new Date(),false,900,true,new Date());
		Producto proped7 = new Comida(0, "lechuga       ", 10.00, 0,"normal",new Date(),true,30,true,new Date(121,04,1));
		
		/* El ao "y" est representado por un entero igual a ("y" - 1900). Por ejemplo el ao 2004 se representa como 104 (2004 - 1900).
		* Los meses son representados por nmeros entre 0 y 11, donde enero es 0 y diciembre es 11.
		* Los das y minutos se representan de forma corriente. Entre 1 - 31 y 0 - 59 respectivamente*/
		
		/* versin de la evaluacin 2
		Producto proped1 = new Bebida(0, "AGUA CON GAS", 0.35, 0);
		Producto proped2 = new Comida(0, "BOCADILLO   ", 3.55, 0);
		Producto proped3 = new Bebida(0, "CERVEZA     ", 0.75, 0);
		Producto proped4 = new Bebida(0, "COCACOLA    ", 0.59, 0);
		Producto proped5 = new Comida(0, "HAMBURGUESA ", 3.75, 0);
		Producto proped6 = new Comida(0, "PIZZA       ", 7.55, 0);
		Producto proped7 = new Comida(0, "lechuga       ", 3.50, 0);
		*/

		TreeMap<String, Producto> tmproped = new TreeMap<String, Producto>();
		tmproped.put("1", proped1);
		tmproped.put("2", proped2);
		tmproped.put("3", proped3);
		tmproped.put("4", proped4);
		tmproped.put("5", proped5);
		tmproped.put("6", proped6);
		tmproped.put("7", proped7);
		
		
		return tmproped;
	}
	
	//@Override
	public static void imprimir(Pedido ped) {
		System.out.println("");
		System.out.println("**** SU TICKET ****************************");
		ped.mostrar();
		System.out.println("*******************************************");
	}
	
	public static void mostrarOfertasyCaducados() {
		// COPIO EL TREEMAP DE LOS PRODUCTOS EN UN ARRAYLIST PARA LUEGO ITERAR
		TreeMap<String, Producto> tmOfertas = main_crearTreeMapProductos();				
		ArrayList<Producto> alprod = new ArrayList<Producto>();
		for(Entry<String, Producto> entry : tmOfertas.entrySet()) { 
					
			String key = entry.getKey();
			Producto value = entry.getValue();
			
			alprod.add(value);
			
		}
							
		Date f_actual = new Date();
		DateFormat df = new SimpleDateFormat("dd-MM-yyyy");
		
		for(int i=0;i<alprod.size();i++) {
			
			Date caducidad = alprod.get(i).obtener_caducidad();
			// 86400000 son milisegundos que tiene un da
			int dias=(int) ((f_actual.getTime()-caducidad.getTime())/86400000);
											
			if(dias>=0) {			
				alprod.get(i).setEstado("CADUCADO");
			}
			
			if(dias<0 && dias>-5) {
				alprod.get(i).setEstado("OFERTA");
				//precio=precio-(0.30*precio);
			}					
		}
		
		System.out.println("");
		System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%");
		System.out.println("PRODUCTOS EN OFERTA!!! :");
		for(int i=0;i<alprod.size();i++) {
			if(alprod.get(i).getEstado().equals("OFERTA")) {
				System.out.println(alprod.get(i).getNombre());
			}
		}
		System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%");
		System.out.println("");
		
		System.out.println("");
		System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
		System.out.println("CARTA SIN PRODUCTOS CADUCADOS :");
		for(int i=0;i<alprod.size();i++) {
			if(! alprod.get(i).getEstado().equals("CADUCADO")) {
				System.out.println(alprod.get(i).getNombre());
			}
		}
		System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
		System.out.println("");
	}
	
	
	public static void main(String args[]) throws ArrayIndexOutOfBoundsException,NumberFormatException{
		
		String operacion; // para agregar, eliminar, borrar o salir
		String phone=""; // para identificar al cliente
		TreeMap<String, Cliente> tm = main_crearClientesEnTreeMap();
		ArrayList<Producto> prolist = main_crearArrayProductos();
		
		
		
		//serializo la lista (la guardo en productos.dat)
		System.out.println("*** Guardamos productos en archivo productos.dat ***");
		try {
			guarda_Productos(prolist);
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		System.out.println("*** Productos guardados en productos.dat ***");
		     
	     //deserializo la lista y la recorro imprimiendo el toString() implicitamente
		System.out.println("\n*** Productos cargados desde archivo productos.dat ***\n");
	     try {
			for (Producto prod : carga_Productos()) {
			     System.out.println(prod.getNombre());
			 }
		} catch (IOException e1) {
			e1.printStackTrace();
		} 
	     System.out.println("\n*** Fin de carga desde productos.dat ***");
		
		do{
						
			// nos aseguramos que el telfono es correcto y lo guardamos
			try {
				phone = Cliente.filtrarTelefono();
			} catch (Cliente.excepcionTelefono e) {
				e.printStackTrace();
			}
			// si el telfono es cero, saldremos del programa
			if (!phone.equals("0")){
				// con el telfono, obtenemos al cliente
				Cliente cl = tm.get(phone);
				
				if (cl != null){
					
					System.out.println("Cliente encontrado: " + tm.get(phone));
					System.out.println("");
					Pedido ped = new Pedido(cl);
								
					boolean continuar = true;
					do{
						// escogemos del men si queremos agregar,eliminar,pagar o salir
						operacion = menuOperacion(); // en opcion, no operacion
						
						if (!operacion.equals("1") && !operacion.equals("2") && !operacion.equals("3") && !operacion.equals("0"))
							System.out.println("Error, inserta 1,2,3 o 0 para salir");
							//throw new NumberFormatException("Error, inserta 1,2,3 o 0 para salir");
						
						// Agregar producto
						if (operacion.equals("1")) {
							
							//////////////////  OFERTAS  Y CADUCADOS ///////////////////							
							mostrarOfertasyCaducados();		
							//////////////////// FIN OFERTAS Y CADUCADOS ////////////////
												
							main_agregarProductos(ped, prolist);
						}
						// Eliminar producto siempre y cuando exista alguno
						if (operacion.equals("2")) {
							if(inventario==0) {
								System.out.println("NO HAY NADA POR ELIMINAR");							
							}else {
								main_borrarProducto(ped);
							}
						}
						// continuamos con el pago si hay productos e imprimimos el resumen de pedido
						if(operacion.equals("3")) {
							if(inventario==0) {
								System.out.println("NO TIENES PRODUCTOS PARA PAGAR");
								ped.ImporteTotal=0;
							}else {
								continuar = main_resumen(ped, cl);
								imprimir(ped);
								
								
								System.out.println("*** GUARDAMOS CLIENTE EN FICHERO ***");
								EscribirFichero(cl);
								System.out.println("*** FIN GUARDAR CLIENTE EN FICHERO ***");
								
																
								System.out.println("*** CARGAMOS CLIENTES DESDE FICHERO ***");
								LeerFichero();
								System.out.println("*** FIN CARGAR CLIENTE DESDE FICHERO ***");
								
								
								resettmproped();
							}
						}
						// salir del programa y nos aseguramos de limpiar el pedido temporal
						if(operacion.equals("0")) {		
							continuar = false;							
						}
													
					} while (continuar);
				} else{
					System.out.println("ERROR, El cliente no existe!!");
				}
			} else{
				System.out.println("\nGRACIAS POR USAR NUESTRO SOFTWARE!");
				phone = "0";
			}
		} while (!phone.equals("0") );

	} // fin main



} // Fin class GestionPedidos

