
import java.util.Date;
import java.util.HashSet;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Comparator;
import java.util.Scanner;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Collections;


public class Pedido implements Serializable{
	 Cliente c;
	 Date FechaHora = new Date(); // Sera la fecha actual
	 double ImporteTotal;
	 PasarelaDePago pago;
	 String estado;
	
	// Creo HashSet en vez TreeSet porque a pesar de que TreeSet
	// mantiene los elementos ordenados, no s por qu no me permite usar "contains"
	// en el mtodo agregarProducto
	HashSet<Producto> hsProducto;
	ArrayList<Producto> alProducto;

	
	String tipo; // si la tarjeta es visa,mastercard o a.express
	String numTarjeta;

	
	static final String cuenta="ESB4 10 1234 12345678"; // nmero de cuenta imaginaria
	
	DateFormat df = new SimpleDateFormat("HH:mm:ss  dd-MM-yyyy");
	
	
	public Pedido(Cliente c) {
		this.setCliente(c);
		hsProducto = new HashSet<Producto>();
		alProducto = new ArrayList<>(hsProducto);
	}
	
	public Pedido(Cliente c,Date fech,ArrayList<Producto> productos,double ImporteTotal,PasarelaDePago pago,String estado){
		this.setCliente(c);
		this.setFechaHora(FechaHora);
		this.setProducto(productos);
		this.setImporteTotal(ImporteTotal);
		this.setPago(pago);
		this.setEstado(estado);
	}
	
	
	// Mtodos GET/SET
	public void setCliente(Cliente c) {
		this.c=c;
	}
	public Cliente getCliente() {
		return c;
	}
	
	public void setFechaHora(Date Fh) { 		
		FechaHora=Fh;
	}
	public Date getFechaHora() {		
		return FechaHora;
	}
	
	public void setProducto(ArrayList<Producto> pro) {
		alProducto=pro;
	}
	public ArrayList<Producto> getProducto(){
		return alProducto;
	}
	
	public void setImporteTotal(double ImporteTotal) {	
		this.ImporteTotal=ImporteTotal;
	}
	
	public double getImporteTotal() {
		// Redondeo del importe
		BigDecimal resultado = new BigDecimal(ImporteTotal);
		resultado = resultado.setScale(2,RoundingMode.HALF_UP);
		return resultado.doubleValue();
	}
	
	public void setPago(PasarelaDePago pago) {
		this.pago=pago;
	}
	public PasarelaDePago getPago() {
		return pago;
	}
	
	public void setEstado(String est) {
		estado=est;
	}
	public String getEstado() {
		return estado;
	}
	
	// Otros Mtodos
	
	public void mostrar() {
		
			System.out.println("ITEM\t\tCANT.\t\tPRODUCTO\t\tPRECIO UD.\t\tTOTAL"
    		+ "\n====\t\t====\t\t========\t\t========\t\t====");
		
			Iterator i = alProducto.iterator();		
			while(i.hasNext()) { 
				System.out.println(i.next());				
			}
			
			/*		 con un for en vez de iterador	
			for(int j=0; j<alProducto.size(); j++) {
				System.out.println(alProducto.get(j));
			}*/
			
			System.out.println("\nTOTAL--------------->"+getImporteTotal());			
	} 
	
	public void Pagar(String TipoPago) throws PasarelaDePago.excepcionCuenta, PasarelaDePago.excepcionTarjeta {
		
		//if(TipoPago==GestionPedidos.tipoPago_efectivo) {
		if(TipoPago.equals(GestionPedidos.tipoPago_efectivo)) {	
			try {
				pago.Efectivo();
			} catch (PasarelaDePago.ExceptionImporte e) {
				e.printStackTrace();
				System.err.println("NO has alcanzado el Importe !!");
				System.exit(0);
			} // pago es objeto pasarela de pago, variable global
		}
		
		//if(TipoPago==GestionPedidos.tipoPago_tarjeta) {
		if(TipoPago.equals(GestionPedidos.tipoPago_tarjeta)) {	
			Scanner sctipo = new Scanner(System.in);
			do {
				System.out.println("\n");
				System.out.println("SUB-MENU\n********\n");
				System.out.println("1. Visa");
				System.out.println("2. Mastercard");
				System.out.println("3. American Express \n");
				System.out.print("Elige tipo de tarjeta: ");
				
				tipo = sctipo.nextLine();				
			
			}while(!tipo.equals("1") && !tipo.equals("2") && !tipo.equals("3"));
			
			boolean valida=true;
			do {
				System.out.print("\n INTRODUZCA EL NUMERO DE TARJETA: ");
				Scanner leeTarjeta = new Scanner(System.in);
				numTarjeta = leeTarjeta.nextLine();
				
				try {
					valida=pago.tarjeta(numTarjeta,tipo);
				} catch (PasarelaDePago.excepcionTarjeta e) {
					e.printStackTrace();
				}				
			
			}while(valida==false);			
		}
		
		//if(TipoPago==GestionPedidos.tipoPago_cuenta) {
		if(TipoPago.equals(GestionPedidos.tipoPago_cuenta)) {	
			PasarelaDePago.Cuenta(cuenta);
		}		
		setEstado("PAGADO");
	}
	

	
	public void agregarProducto(Producto producto) { 
		// si no lo hago, item empezar por 0
		if(hsProducto.contains(producto)==false) { // no necesito recorrer, con
			producto.item=hsProducto.size()+1;		// el primero vale	
		} // solo aumento el item  numero de linea si el producto es nuevo en lista
		
		producto.setVeces(producto.getVeces()+1);
 		producto.setSubtotal(producto.getPrecio()+producto.getSubtotal());			

		hsProducto.add(producto); // al ser listado un HashSet, no repite lineas de producto
		//ImporteTotal=ImporteTotal+producto.precio;
		
		//ImporteTotal=ImporteTotal+(producto.precio-(0.30*producto.precio));

		
		// Creo un Array y le paso al HashSet de productos "listado"
		alProducto=new ArrayList<>(hsProducto);
		
		// Ahora puedo ordenar el ArryList por el nmero de Item de producto
		
		Collections.sort(alProducto, new Comparator<Producto>() {
			@Override // Devuelve un entero positivo si el item de p1 es mayor que la de p2
			public int compare(Producto p1, Producto p2) {
				return new Integer(p1.getItem()).compareTo(new Integer(p2.getItem()));
			}

		});
	}
	
	
	public void eliminarProducto(int posicion) {
		
		//System.out.println("Eliminando producto....");
		
		// recorro el arrayList de productos
			for(int i=0;i<alProducto.size();i++) {
				// si coincide la posicion con el nmero de item
				if(posicion==alProducto.get(i).getItem()){
					// si solo queda un artculo, eliminamos la lnea del producto
					if(alProducto.get(i).getVeces()==1) {
												
						// Recorro de nuevo alProducto, que ahora tiene un elemento menos
						// y les resto el valor de item
						for(int z=0;z<alProducto.size();z++) {			
							if(alProducto.get(z).getItem()>posicion) {
								alProducto.get(z).setItem(alProducto.get(z).getItem()-1);
							}
						}	
						// Recalculamos el importe Total						
						ImporteTotal=ImporteTotal-alProducto.get(i).getPrecio(); 
						
						//System.out.println("Producto que se va a eliminar: "+alProducto.get(i));
						alProducto.remove(i);		
						
						// Re-ordeno miArray tras eliminar un elemento-producto
						Collections.sort(alProducto, new Comparator<Producto>() {
							@Override
							public int compare(Producto p1, Producto p2) {
								return new Integer(p1.getItem()).compareTo(new Integer(p2.getItem()));
							}

						});
						
						
						// si hay mas de un artculo le restamos el nmero de "veces" y recalculo subtotal e importe total	
					}else {
							alProducto.get(i).setVeces(alProducto.get(i).getVeces()-1);
							alProducto.get(i).setSubtotal(alProducto.get(i).getSubtotal()-alProducto.get(i).getPrecio());
							ImporteTotal=ImporteTotal-alProducto.get(i).getPrecio();					 
						}
				}
			}  // fin for
			
			
		mostrar();
		
		// vuelco de nuevo el arraylist al hashset para cuando vuelva a agregar
		hsProducto = new HashSet<>(alProducto);

	} // fin metodo eliminarProducto
	
	public Producto buscar(Producto proTmp){
		Producto p;
		for(int i=0; i<alProducto.size(); i++) {
			p=alProducto.get(i);
			if (p.nombre.equals(proTmp.nombre))
				return p;
		}
		return null;
	}

	@Override
    public String toString() {
				
		return "\nPEDIDO: "+
				"\nFecha Pedido: "+df.format(getFechaHora())+
				"\nProductos: "+getProducto()+
				"\nImporte: "+getImporteTotal()+
				"\nEstado: "+getEstado()+"\n";
    }
	
}

