import java.text.SimpleDateFormat;
import java.util.Date;
import java.text.DateFormat;
import java.text.ParseException;
import java.io.Serializable;

public abstract class Producto implements Serializable{
	String nombre;
	double precio;
	
	int veces=0; // para la cantidad del mismo producto en el pedido
	double subtotal; // para el precio por linea de cada producto
	int item; // para identificar cada lnea de productos del pedido
	
	String estado; // 
	Date fecha_caducidad;
	DateFormat df = new SimpleDateFormat("dd-MM-yyyy");
	
	// constructor con fecha de caducidad y estado
	public Producto (String nombre, double precio, Date fecha_caducidad,String estado) {
		this.setNombre(nombre);
		this.setPrecio(precio);
		this.setFecha_caducidad(fecha_caducidad);
		this.setEstado(estado);
	}
	
	// Constructor para el men para elegir productos
	public Producto(String nombre,double precio) {		
		this.setNombre(nombre);
		this.setPrecio(precio);
	}
	
	// constructor con fecha de caducidad para comida y bebida
	//public Producto(int veces,String nombre,double precio,double subtotal,String fcad) {
	public Producto(int veces,String nombre,double precio,double subtotal,String estado,Date fecha_caducidad) {
		this.setVeces(veces);
		this.setNombre(nombre);
		this.setPrecio(precio);
		this.setSubtotal(subtotal);
		this.setEstado(estado);
		this.setFecha_caducidad(fecha_caducidad);
	}
	
	/*
	 * A la hora de mostrar la carta de productos, se debe comprobar la
	 *  fecha de caducidad del mismo. Si el producto est prximo a 
	 *  su fecha de caducidad (menos de cinco das), 
	 *  se debe mostrar la palabra OFERTAdelante(o arriba)y un descuento 
	 *  en el precio del 30%Si el producto ya ha excedido el lmite permitido 
	 *  de la fecha de caducidadno se muestra en la cartay el campo estado 
	 *  se pone con el valor CADUCADO
	 */
	
	public static void Ofertas(Date f_envasado,Date f_caducidad){
		Date f_actual = new Date();
	}

	// Constructor para mostrar los productos que aadimos al pedido
	public Producto(int veces,String nombre,double precio,double subtotal) {
		this.setVeces(veces);
		this.setNombre(nombre);
		this.setPrecio(precio);
		this.setSubtotal(subtotal);
	}
	
	// 
	
	// GETTERS Y SETTERS
	
	public Date getFecha_caducidad() {
		return fecha_caducidad;
	}

	public void setFecha_caducidad(Date fecha_caducidad) {
		this.fecha_caducidad = fecha_caducidad;
	}
	
	public void setNombre(String nombre) {
		this.nombre=nombre.toUpperCase();
	}


	public String getNombre() {
		return nombre;
	}
	
	public void setPrecio(double precio) {			
		//precio = Math.round(precio*100.0)/100.0;
		this.precio=precio;
	}
	public double getPrecio() {
		return precio;
	}
	
	public void setVeces(int veces) {
		this.veces=veces;
	}
	public int getVeces() {
		return veces;
	}
	
	public void setItem(int item) {
		this.item=item;
	}
	public int getItem() {
		return item;
	}
	
	public void setSubtotal(double subtotal) {
		this.subtotal=subtotal;
	}
	public double getSubtotal() {
		return subtotal;
	}
	
	public String getEstado() {
		return estado;
	}

	public void setEstado(String estado) {
		this.estado = estado;
	}
	
	// FIN GETTERS Y SETTERS
	
	public abstract Date obtener_caducidad();
	
	public abstract void detalle_producto();
	

	@Override
	public String toString() {
		
		return getItem()+"\t\t"+getVeces()+"\t\t"+getNombre()+"\t\t"+getPrecio()+"\t\t\t"+getSubtotal();
	}

}
